/// <reference types="node" />
export declare const NULL_BUFFER: Buffer;
export declare function buildAuthBuffer(user: string): {
    authBuffer: Buffer;
    randomString: string;
};
declare type VersionMessage = {
    max_protocol_version: number;
    min_protocol_version: number;
    server_version: string;
};
export declare function validateVersion(msg: VersionMessage): void;
export declare function computeSaltedPassword(authString: string, randomString: string, user: string, password: Buffer): Promise<{
    serverSignature: string;
    proof: Buffer;
}>;
export declare function compareDigest(authentication: string, serverSignature: string): void;
export {};
