/// <reference types="node" />
import { EventEmitter } from 'events';
import { TermJson } from '../internal-types';
import { Cursor } from '../response/cursor';
import { Connection, MasterPool, RPoolConnectionOptions, RunOptions } from '../types';
import { ServerConnectionPool } from './server-pool';
export declare class MasterConnectionPool extends EventEmitter implements MasterPool {
    draining: boolean;
    private healthy;
    private discovery;
    private discoveryCursor?;
    private servers;
    private serverPools;
    private connParam;
    constructor({ db, user, password, discovery, servers, buffer, max, timeout, pingInterval, timeoutError, timeoutGb, maxExponent, silent, log, }?: RPoolConnectionOptions);
    setOptions({ discovery, buffer, max, timeoutError, timeoutGb, maxExponent, silent, log, }: {
        discovery?: boolean | undefined;
        buffer?: number | undefined;
        max?: number | undefined;
        timeoutError?: number | undefined;
        timeoutGb?: number | undefined;
        maxExponent?: number | undefined;
        silent?: boolean | undefined;
        log?: ((message: string) => any) | undefined;
    }): void;
    eventNames(): string[];
    initServers(serverNum?: number): Promise<void>;
    get isHealthy(): boolean;
    waitForHealthy(): Promise<this>;
    drain(): Promise<void>;
    getPools(): ServerConnectionPool[];
    getConnections(): Connection[];
    getLength(): number;
    getAvailableLength(): number;
    queue(term: TermJson, globalArgs?: RunOptions): Promise<Cursor | undefined>;
    private createServerPool;
    private setServerPoolsOptions;
    private discover;
    private getServerFromStatus;
    private removeServer;
    private subscribeToPool;
    private setHealthy;
    private closeServerPool;
    private getHealthyServerPools;
    private getPoolWithMinQueries;
    private getOpenConnections;
    private getIdleConnections;
}
