import { RethinkDBErrorType } from '../types';
import { TermJson } from '../internal-types';
import { ErrorType, ResponseType } from '../proto/enums';
export interface RethinkDBErrorArgs {
    cause?: Error;
    type?: RethinkDBErrorType;
    errorCode?: number;
    term?: TermJson;
    backtrace?: Array<number | string>;
    responseType?: ResponseType;
    responseErrorType?: ErrorType;
}
export declare class RethinkDBError extends Error {
    msg: string;
    readonly cause: Error | undefined;
    readonly type: RethinkDBErrorType;
    private term?;
    constructor(msg: string, args?: RethinkDBErrorArgs);
}
export declare function isRethinkDBError(error: unknown): error is RethinkDBError;
