"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasImplicitVar = void 0;
const enums_1 = require("../proto/enums");
function hasImplicitVar(term) {
    if (!Array.isArray(term)) {
        if (term !== null && typeof term === 'object') {
            return Object.values(term).some((value) => hasImplicitVar(value));
        }
        return false;
    }
    if (term[0] === enums_1.TermType.IMPLICIT_VAR) {
        return true;
    }
    const termParam = term[1];
    if (termParam) {
        return termParam.some((value) => hasImplicitVar(value));
    }
    return false;
}
exports.hasImplicitVar = hasImplicitVar;
