"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseOptarg = void 0;
const util_1 = require("../util");
const param_parser_1 = require("./param-parser");
function parseOptarg(obj) {
    if (!(0, util_1.isObject)(obj) || Array.isArray(obj)) {
        return undefined;
    }
    return Object.entries(obj).reduce((acc, [key, value]) => {
        acc[(0, util_1.camelToSnake)(key)] = (0, param_parser_1.parseParam)(value);
        return acc;
    }, {});
}
exports.parseOptarg = parseOptarg;
