"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rConsts = exports.rConfig = exports.termConfig = exports.funcall = exports.bracket = void 0;
const enums_1 = require("../proto/enums");
exports.bracket = [enums_1.TermType.BRACKET, '(...)', 1, 1, false];
exports.funcall = [enums_1.TermType.FUNCALL, 'do', 1, -1, false];
exports.termConfig = [
    [enums_1.TermType.TABLE, 'table', 1, 2, 'last'],
    [enums_1.TermType.GET, 'get', 1, 1, false],
    [enums_1.TermType.GET_ALL, 'getAll', 0, -1, 'optional'],
    [enums_1.TermType.EQ, 'eq', 1, -1, false],
    [enums_1.TermType.NE, 'ne', 1, -1, false],
    [enums_1.TermType.LT, 'lt', 1, -1, false],
    [enums_1.TermType.LE, 'le', 1, -1, false],
    [enums_1.TermType.GT, 'gt', 1, -1, false],
    [enums_1.TermType.GE, 'ge', 1, -1, false],
    [enums_1.TermType.NOT, 'not', 0, 0, false],
    [enums_1.TermType.ADD, 'add', 1, -1, false],
    [enums_1.TermType.SUB, 'sub', 1, -1, false],
    [enums_1.TermType.MUL, 'mul', 1, -1, false],
    [enums_1.TermType.DIV, 'div', 1, -1, false],
    [enums_1.TermType.MOD, 'mod', 1, 1, false],
    [enums_1.TermType.FLOOR, 'floor', 0, 0, false],
    [enums_1.TermType.CEIL, 'ceil', 0, 0, false],
    [enums_1.TermType.ROUND, 'round', 0, -1, false],
    [enums_1.TermType.APPEND, 'append', 1, 1, false],
    [enums_1.TermType.PREPEND, 'prepend', 1, 1, false],
    [enums_1.TermType.DIFFERENCE, 'difference', 1, 1, false],
    [enums_1.TermType.SET_INSERT, 'setInsert', 1, 1, false],
    [enums_1.TermType.SET_INTERSECTION, 'setIntersection', 1, 1, false],
    [enums_1.TermType.SET_UNION, 'setUnion', 1, 1, false],
    [enums_1.TermType.SET_DIFFERENCE, 'setDifference', 1, 1, false],
    [enums_1.TermType.SLICE, 'slice', 1, 3, 'last-optional'],
    [enums_1.TermType.SKIP, 'skip', 1, 1, false],
    [enums_1.TermType.LIMIT, 'limit', 1, 1, false],
    [enums_1.TermType.OFFSETS_OF, 'offsetsOf', 1, 1, false],
    [enums_1.TermType.CONTAINS, 'contains', 1, -1, false],
    [enums_1.TermType.GET_FIELD, 'getField', 1, 1, false],
    [enums_1.TermType.KEYS, 'keys', 0, 0, false],
    [enums_1.TermType.VALUES, 'values', 0, 0, false],
    [enums_1.TermType.HAS_FIELDS, 'hasFields', 1, -1, false],
    [enums_1.TermType.WITH_FIELDS, 'withFields', 1, -1, false],
    [enums_1.TermType.PLUCK, 'pluck', 1, -1, false],
    [enums_1.TermType.WITHOUT, 'without', 1, -1, false],
    [enums_1.TermType.MERGE, 'merge', 1, -1, false],
    [enums_1.TermType.BETWEEN, 'between', 2, 3, 'last'],
    [enums_1.TermType.REDUCE, 'reduce', 1, 1, false],
    [enums_1.TermType.MAP, 'map', 1, -1, false],
    [enums_1.TermType.FOLD, 'fold', 2, 3, 'last'],
    [enums_1.TermType.FILTER, 'filter', 1, 2, 'last'],
    [enums_1.TermType.CONCAT_MAP, 'concatMap', 1, 1, false],
    [enums_1.TermType.ORDER_BY, 'orderBy', 1, -1, 'optional'],
    [enums_1.TermType.DISTINCT, 'distinct', 0, 1, 'last'],
    [enums_1.TermType.COUNT, 'count', 0, 1, false],
    [enums_1.TermType.IS_EMPTY, 'isEmpty', 0, 0, false],
    [enums_1.TermType.UNION, 'union', 0, -1, 'optional'],
    [enums_1.TermType.NTH, 'nth', 1, 1, false],
    [enums_1.TermType.INNER_JOIN, 'innerJoin', 2, 2, false],
    [enums_1.TermType.OUTER_JOIN, 'outerJoin', 2, 2, false],
    [enums_1.TermType.EQ_JOIN, 'eqJoin', 2, 3, 'last'],
    [enums_1.TermType.ZIP, 'zip', 0, 0, false],
    [enums_1.TermType.INSERT_AT, 'insertAt', 2, 2, false],
    [enums_1.TermType.DELETE_AT, 'deleteAt', 1, 2, false],
    [enums_1.TermType.CHANGE_AT, 'changeAt', 2, 2, false],
    [enums_1.TermType.SPLICE_AT, 'spliceAt', 2, 2, false],
    [enums_1.TermType.COERCE_TO, 'coerceTo', 1, 1, false],
    [enums_1.TermType.TYPE_OF, 'typeOf', 0, 0, false],
    [enums_1.TermType.UPDATE, 'update', 1, 2, 'last'],
    [enums_1.TermType.DELETE, 'delete', 0, 1, 'last'],
    [enums_1.TermType.REPLACE, 'replace', 1, 2, 'last'],
    [enums_1.TermType.INSERT, 'insert', 1, 2, 'last'],
    [enums_1.TermType.TABLE_CREATE, 'tableCreate', 1, 2, 'last'],
    [enums_1.TermType.TABLE_DROP, 'tableDrop', 1, 1, false],
    [enums_1.TermType.TABLE_LIST, 'tableList', 0, 0, false],
    [enums_1.TermType.CONFIG, 'config', 0, 0, false],
    [enums_1.TermType.STATUS, 'status', 0, 0, false],
    [enums_1.TermType.WAIT, 'wait', 0, 1, 'last'],
    [enums_1.TermType.RECONFIGURE, 'reconfigure', 1, 1, 'required'],
    [enums_1.TermType.REBALANCE, 'rebalance', 0, 0, false],
    [enums_1.TermType.SYNC, 'sync', 0, 0, false],
    [enums_1.TermType.GRANT, 'grant', 2, 2, false],
    [enums_1.TermType.INDEX_CREATE, 'indexCreate', 1, 3, 'last-optional'],
    [enums_1.TermType.INDEX_DROP, 'indexDrop', 1, 1, false],
    [enums_1.TermType.INDEX_LIST, 'indexList', 0, 0, false],
    [enums_1.TermType.INDEX_STATUS, 'indexStatus', 0, -1, false],
    [enums_1.TermType.INDEX_WAIT, 'indexWait', 0, -1, false],
    [enums_1.TermType.INDEX_RENAME, 'indexRename', 2, 3, 'last'],
    [enums_1.TermType.BRANCH, 'branch', 2, -1, false],
    [enums_1.TermType.OR, 'or', 0, -1, false],
    [enums_1.TermType.AND, 'and', 0, -1, false],
    [enums_1.TermType.FOR_EACH, 'forEach', 1, 1, false],
    [enums_1.TermType.INFO, 'info', 0, 0, false],
    [enums_1.TermType.MATCH, 'match', 1, 1, false],
    [enums_1.TermType.UPCASE, 'upcase', 0, 0, false],
    [enums_1.TermType.DOWNCASE, 'downcase', 0, 0, false],
    [enums_1.TermType.SAMPLE, 'sample', 1, 1, false],
    [enums_1.TermType.DEFAULT, 'default', 1, 1, false],
    [enums_1.TermType.TO_ISO8601, 'toISO8601', 0, 0, false],
    [enums_1.TermType.TO_EPOCH_TIME, 'toEpochTime', 0, 0, false],
    [enums_1.TermType.IN_TIMEZONE, 'inTimezone', 1, 1, false],
    [enums_1.TermType.DURING, 'during', 2, 3, 'last'],
    [enums_1.TermType.DATE, 'date', 0, 0, false],
    [enums_1.TermType.TIME_OF_DAY, 'timeOfDay', 0, 0, false],
    [enums_1.TermType.TIMEZONE, 'timezone', 0, 0, false],
    [enums_1.TermType.YEAR, 'year', 0, 0, false],
    [enums_1.TermType.MONTH, 'month', 0, 0, false],
    [enums_1.TermType.DAY, 'day', 0, 0, false],
    [enums_1.TermType.DAY_OF_WEEK, 'dayOfWeek', 0, 0, false],
    [enums_1.TermType.DAY_OF_YEAR, 'dayOfYear', 0, 0, false],
    [enums_1.TermType.HOURS, 'hours', 0, 0, false],
    [enums_1.TermType.MINUTES, 'minutes', 0, 0, false],
    [enums_1.TermType.SECONDS, 'seconds', 0, 0, false],
    [enums_1.TermType.GROUP, 'group', 0, -1, 'optional'],
    [enums_1.TermType.SUM, 'sum', 0, 1, false],
    [enums_1.TermType.AVG, 'avg', 0, 1, false],
    [enums_1.TermType.MIN, 'min', 0, 1, 'optional'],
    [enums_1.TermType.MAX, 'max', 0, 1, 'optional'],
    [enums_1.TermType.SPLIT, 'split', 0, 2, false],
    [enums_1.TermType.UNGROUP, 'ungroup', 0, 0, false],
    [enums_1.TermType.CHANGES, 'changes', 0, 1, 'last'],
    [enums_1.TermType.TO_GEOJSON, 'toGeojson', 0, 0, false],
    [enums_1.TermType.DISTANCE, 'distance', 1, 2, 'last'],
    [enums_1.TermType.INTERSECTS, 'intersects', 1, 1, false],
    [enums_1.TermType.INCLUDES, 'includes', 1, 1, false],
    [enums_1.TermType.GET_INTERSECTING, 'getIntersecting', 2, 2, 'required'],
    [enums_1.TermType.FILL, 'fill', 0, 0, false],
    [enums_1.TermType.GET_NEAREST, 'getNearest', 2, 2, 'required'],
    [enums_1.TermType.POLYGON_SUB, 'polygonSub', 1, 1, false],
    [enums_1.TermType.TO_JSON_STRING, 'toJSON', 0, 0, false],
    [enums_1.TermType.TO_JSON_STRING, 'toJsonString', 0, 0, false],
    // not documented
    [enums_1.TermType.SET_WRITE_HOOK, 'setWriteHook', 1, 1, false],
    [enums_1.TermType.GET_WRITE_HOOK, 'getWriteHook', 0, 0, false],
    [enums_1.TermType.BIT_AND, 'bitAnd', 1, -1, false],
    [enums_1.TermType.BIT_OR, 'bitOr', 1, -1, false],
    [enums_1.TermType.BIT_XOR, 'bitXor', 1, -1, false],
    [enums_1.TermType.BIT_NOT, 'bitNot', 0, 0, false],
    [enums_1.TermType.BIT_SAL, 'bitSal', 1, -1, false],
    [enums_1.TermType.BIT_SAL, 'bitShl', 1, -1, false],
    [enums_1.TermType.BIT_SAR, 'bitSar', 1, -1, false],
    [197 /* TermType.BIT_SHR */, 'bitShr', 1, -1, false],
];
exports.rConfig = [
    [enums_1.TermType.ASC, 'asc', 1, 1, false],
    [enums_1.TermType.DESC, 'desc', 1, 1, false],
    [enums_1.TermType.EPOCH_TIME, 'epochTime', 1, 1, false],
    [enums_1.TermType.NOW, 'now', 0, 0, false],
    [enums_1.TermType.TIME, 'time', 4, 7, false],
    [enums_1.TermType.ISO8601, 'ISO8601', 1, 2, 'last'],
    [enums_1.TermType.BINARY, 'binary', 1, 1, false],
    [enums_1.TermType.JSON, 'json', 1, 1, false],
    [enums_1.TermType.OBJECT, 'object', 1, -1, false],
    [enums_1.TermType.POINT, 'point', 2, 2, false],
    [enums_1.TermType.LINE, 'line', 2, -1, false],
    [enums_1.TermType.POLYGON, 'polygon', 3, -1, false],
    [enums_1.TermType.CIRCLE, 'circle', 2, 3, 'last'],
    [enums_1.TermType.GEOJSON, 'geojson', 1, 1, false],
    [enums_1.TermType.ARGS, 'args', 1, 1, false],
    [enums_1.TermType.ERROR, 'error', 0, 1, false],
    [enums_1.TermType.JAVASCRIPT, 'js', 1, 2, 'last'],
    [enums_1.TermType.LITERAL, 'literal', 0, 1, false],
    [enums_1.TermType.RANDOM, 'random', 0, 3, 'last-optional'],
    [enums_1.TermType.RANGE, 'range', 1, 2, false],
    [enums_1.TermType.UUID, 'uuid', 0, 1, false],
    [enums_1.TermType.HTTP, 'http', 1, 2, 'last'],
    [enums_1.TermType.GRANT, 'grant', 2, 2, false],
    [enums_1.TermType.DB, 'db', 1, 1, false],
    [enums_1.TermType.DB_CREATE, 'dbCreate', 1, 1, false],
    [enums_1.TermType.DB_DROP, 'dbDrop', 1, 1, false],
    [enums_1.TermType.DB_LIST, 'dbList', 0, 0, false],
    [enums_1.TermType.TABLE, 'table', 1, 2, 'last'],
    [enums_1.TermType.TABLE_CREATE, 'tableCreate', 1, 2, 'last'],
    [enums_1.TermType.TABLE_DROP, 'tableDrop', 1, 1, false],
    [enums_1.TermType.TABLE_LIST, 'tableList', 0, 0, false],
];
exports.rConsts = [
    [enums_1.TermType.IMPLICIT_VAR, 'row'],
    [enums_1.TermType.MINVAL, 'minval'],
    [enums_1.TermType.MAXVAL, 'maxval'],
    [enums_1.TermType.MONDAY, 'monday'],
    [enums_1.TermType.TUESDAY, 'tuesday'],
    [enums_1.TermType.WEDNESDAY, 'wednesday'],
    [enums_1.TermType.THURSDAY, 'thursday'],
    [enums_1.TermType.FRIDAY, 'friday'],
    [enums_1.TermType.SATURDAY, 'saturday'],
    [enums_1.TermType.SUNDAY, 'sunday'],
    [enums_1.TermType.JANUARY, 'january'],
    [enums_1.TermType.FEBRUARY, 'february'],
    [enums_1.TermType.MARCH, 'march'],
    [enums_1.TermType.APRIL, 'april'],
    [enums_1.TermType.MAY, 'may'],
    [enums_1.TermType.JUNE, 'june'],
    [enums_1.TermType.JULY, 'july'],
    [enums_1.TermType.AUGUST, 'august'],
    [enums_1.TermType.SEPTEMBER, 'september'],
    [enums_1.TermType.OCTOBER, 'october'],
    [enums_1.TermType.NOVEMBER, 'november'],
    [enums_1.TermType.DECEMBER, 'december'],
];
