/**
 * Returns true if the given object is a Function. Otherwise, returns false.
 */
declare const isFunction: (value: unknown) => value is Function;
/**
 * Returns true if the given object is strictly an Object and not a Function
 * (even though functions are objects in JavaScript). Otherwise, returns false.
 */
declare const isObject: (value: unknown) => value is Object;
declare function delay(timeInMs: number, options?: {
    unref: boolean;
}): Promise<void>;
declare function snakeToCamel(name: string): string;
declare function camelToSnake(name: string): string;
declare const isDate: (arg: unknown) => arg is Date;
declare const isNativeError: (arg: unknown) => arg is Error;
declare function isPromise(obj: any): obj is Promise<unknown>;
export { camelToSnake, delay, isDate, isFunction, isNativeError, isObject, isPromise, snakeToCamel, };
